P0 	EQU	80H
SP	EQU	81H
DPL	EQU	82H
DPH	EQU	83H
PCON	EQU	87H	
TCON	EQU	88H
TMOD	EQU	89H
TL0	EQU	8AH
TL1	EQU	8BH
TH0	EQU	8CH
TH1	EQU	8DH
P1 	EQU	90H	
SCON	EQU	98H
SBUF	EQU	99H
P2	EQU	0A0H
IE	EQU	0A8H
P3	EQU	0B0H
IP	EQU	0B8H
PSW	EQU	0D0H
ACC	EQU	0E0H
B	EQU	0F0H
TR0	EQU	8CH
TF0	EQU	8DH
RI	EQU	98H
TI	EQU	99H

;----------EQU--------------
KEY_PIN	EQU	P3.1        ;
SAVE_DATA	EQU	R4  ;
DATA_PORT	EQU	P2  ;
RW	EQU	P1.1        ;
RS	EQU	P1.0        ;
E	EQU	P1.2        ;
RST	EQU	P1.5        ;
CS1	EQU	P1.3        ;
CS2	EQU	P1.4        ;
;---------------------------


ORG	00H
	SJMP 	LOAD
	ORG	03H
	INC	R5
	LJMP	KEY_SCAN
	RETI

LOAD: 	
	CLR	RST
	NOP
	NOP
	NOP
	NOP
	NOP
	SETB 	RST
	MOV	R6,#0H
	MOV	R7,#8
	MOV	41H,#40H
	MOV	42H,#0B8H
	MOV	44H,#2
	MOV	TCON,00000001B
	CLR	A
	SETB	KEY_PIN
	mov	R5,#0	
	MOV	IE,#10000001B

;////////////////////////////////////
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;////////////////////////////////////
MAIN: 
	CLR	A
MAIN1:
	JNB	IE.7,DIS
SJMP MAIN1
;///////////////////////////////////
;\\\\\\\\\\\\ADDER DATA\\\\\\\\\\\\\
;///////////////////////////////////

KEY_SCAN:
	CJNE	R5,#2,SCAN_START
	RETI
SCAN_START:
	CJNE	R5,#11,CHECK
	SJMP	STOP_BIT
CHECK:	
	MOV	C,KEY_PIN
	RRC	A
	RETI
STOP_BIT:
	CLR	IE.7
	ACALL	DELAY
	ACALL	DELAY
	MOV	SAVE_DATA,A
	MOV	40H,A
	MOV	R5,#0
	CLR	A
	MOV	DPTR,#400H
STEP6:	
	CLR	A
	MOVC	A,@A+DPTR
	INC	DPTR
	SJMP	STEP7
STEP8:	CJNE	A,40H,STEP6
	RETI
	
STEP7:
	CJNE	A,#0FFH,STEP8
	ACALL	DELAY
	ACALL	DELAY
	SETB	IE.7
	RETI

;////////////////FIND DATA\\\\\\\\\\\\\\\
DIS:	
	ACALL	DELAY
	ACALL	DELAY
	MOV	DPTR,#500H
SCAN:	
	CLR	A
	INC	DPTR
	MOVC	A,@A+DPTR
	SJMP	ENTER	
FIND:	CJNE	A,40H,SCAN
	CLR	A
	INC	DPTR
	MOVC	A,@A+DPTR
	MOV	R2,A
	INC	DPTR
	CLR	A
	MOVC	A,@A+DPTR
	MOV	R3,A
	MOV	DPH,R2
	MOV	DPL,R3
	SJMP	DISPLAY


ENTER:
	CJNE	A,#5AH,FIND
	MOV	A,42H
	CJNE	A,#0BFH,STEP10
	MOV	44H,#2H
	MOV	42H,#0B7H
	MOV	R6,#00H
	SJMP	MAIN	
STEP10:	
	MOV	44H,#2H
	INC	42H
	MOV	R6,#00H
	SETB	IE.7
	SJMP	MAIN
	
	
;/////////////////////END FIND\\\\\\\\\\\\\\\\\\
;\\\\\\\\\\\\\\\\\\\\\        //////////////////


;/////////////////////DISPLAY\\\\\\\\\\\\\\\\\\\
;\\\\\\\\\\\\\\\\\\\\\       ///////////////////




DISPLAY:
	MOV	A,44H
	CJNE	A,#1,STEP1
	SJMP	STEP2	
STEP1:	
	SETB	CS1
	CLR	CS2
	SJMP	AGAIN_1
STEP2:	
	SETB	CS2
	CLR	CS1
	SJMP	AGAIN_1
AGAIN_1:
	CJNE	R6,#0H,READ_DATA
	MOV	DATA_PORT,41H
	ACALL	COMMAND
	MOV	DATA_PORT,42H
	ACALL	COMMAND
	MOV	DATA_PORT,#3FH
	ACALL	COMMAND
	MOV	R6,#8
	SJMP	READ_DATA
READ_DATA:	
	CLR	A
	MOVC	A,@A+DPTR	
	MOV	DATA_PORT,A
	ACALL	DATA_DISPLAY
	INC	DPTR
	DJNZ	R7,READ_DATA
	MOV	R7,#8
	DJNZ	R6,STEP5
	DJNZ	44H,STEP5
	INC	42H
	ACALL	X_CHECK
STEP4:	MOV	44H,#2
	SETB	IE.7
	LJMP	MAIN

STEP5:	SETB	IE.7
	LJMP	MAIN



X_CHECK:
	MOV	A,42H	
	CJNE	A,#0C0H,STEP4
	MOV	42H,#0B8H
RET			
COMMAND:
	CALL	DELAY
	CLR	RW
	CLR	RS
	SETB	E
	CLR	E
	RET

DATA_DISPLAY:
	CALL	DELAY
	CLR	RW
	SETB	RS
	SETB	E
	CLR	E
	RET
;//////////////////END DISPLAY DATA\\\\\\\\\\\\\\\\\
;\\\\\\\\\\\\\\\\\\                /////////////////

	
DELAY:
	MOV	R0,#17
LOOP1: 	MOV	R1,#250
LOOP2:	DJNZ	R1,LOOP2
	DJNZ	R0,LOOP1
RET
				






ORG	200H
db 0,62,81,73,69,62,0,0 ; 0
db 0,0,66,127,64,0,0,0 ; 1
db 0,98,81,73,73,70,0,0 ; 2
db 0,34,73,73,73,54,0,0 ; 3
db 0,24,20,18,127,16,0,0 ; 4
db 0,47,73,73,73,49,0,0 ; 5
db 0,60,74,73,73,48,0,0 ; 6
db 0,1,113,9,5,3,0,0 ; 7
db 0,54,73,73,73,54,0,0 ; 8
db 0,6,73,73,41,30,0,0 ; 9
db 0,126,17,17,17,126,0,0 ; A
db 0,127,73,73,73,54,0,0 ; B
db 0,62,65,65,65,34,0,0 ; C
db 0,127,65,65,65,62,0,0 ; D
db 0,127,73,73,73,65,0,0 ; E
db 0,127,9,9,9,1,0,0 ; F
db 0,62,65,73,73,122,0,0 ; G
db 0,127,8,8,8,127,0,0 ; H
db 0,0,65,127,65,0,0,0 ; I
db 0,48,64,64,64,63,0,0 ; J
db 0,127,8,20,34,65,0,0 ; K
db 0,127,64,64,64,64,0,0 ; L
db 0,127,2,4,2,127,0,0 ; M
db 0,127,2,4,8,127,0,0 ; N
db 0,62,65,65,65,62,0,0 ; O
db 0,127,9,9,9,6,0,0 ; P
db 0,62,65,81,33,94,0,0 ; Q
db 0,127,9,9,25,102,0,0 ; R
db 0,38,73,73,73,50,0,0 ; S
db 0,1,1,127,1,1,0,0 ; T
db 0,63,64,64,64,63,0,0 ; U
db 0,31,32,64,32,31,0,0 ; V
db 0,63,64,60,64,63,0,0 ; W
db 0,99,20,8,20,99,0,0 ; X
db 0,7,8,112,8,7,0,0 ; Y
db 0,113,73,69,67,0,0,0 ; Z
DB 0,0,0,0,0,0,0,0


ORG	400H
DB 70H,69H,72H,7AH,6BH,73H,74H,6CH,75H,7DH,1CH,21H,23H,24H,2BH,34H,33H,43H,3BH,42H,4BH,3AH,31H
DB 44H,4DH,15H,2DH,1BH,2CH,3CH,2AH,1DH,22H,35H,1AH,32H,29H,5AH,0FFH

ORG	500H
DB 22H,03H,08H,70H,02H,00H,69H,02H,08H,72H,02H,10H,7AH,02H,18H,6BH,02H,20H,73H,02H,28H,74H,02H,30H   
DB 6CH,02H,38H,75H,02H,40H,7DH,02H,48H; FOR DIGIT         
DB 1CH,02H,50H,21H,02H,60H,23H,02H,68H,24H,02H,70H,2BH,02H,78H,34H,02H,80H   
DB 33H,02H,88H,43H,02H,90H,3BH,02H,98H,42H,02H,0A0H,4BH,02H,0A8H,3AH,02H,0B0H,31H,02H,0B8H  
DB 44H,02H,0C0H,4DH,02H,0C8H,15H,02H,0D0H,2DH,02H,0D8H,1BH,02H,0E0H,2CH,02H,0E8H,3CH,02H,0F0H                                                                               
DB 2AH,02H,0F8H,1DH,03H,00H,35H,03H,10H,1AH,03H,18H,32H,02H,58H,29H,03H,20H


END	









